package org.ow2.util.ee.metadata.ejbjar.impl.configurator;

import org.ow2.util.ee.deploy.api.deployable.EJBDeployable;
import org.ow2.util.ee.metadata.common.impl.configurator.CommonFieldMetadataConfigurator;
import org.ow2.util.ee.metadata.ejbjar.impl.EjbJarClassMetadata;
import org.ow2.util.ee.metadata.ejbjar.impl.EjbJarFieldMetadata;
import org.ow2.util.ee.metadata.ejbjar.impl.EjbJarMethodMetadata;
import org.ow2.util.scan.api.metadata.structures.JField;

/**
 * EjbJarFieldMetadataConfigurator.
 * @param <E> deployable type
 * @author Gael Lalire
 */
public class EjbJarFieldMetadataConfigurator<E extends EJBDeployable<E>> extends
        CommonFieldMetadataConfigurator<EjbJarClassMetadata<E>, EjbJarMethodMetadata<E>, EjbJarFieldMetadata<E>> {

    /**
     * Constructor.
     * @param jField signature
     * @param classAnnotationMetadata parent
     * @param annotationParsingDesactived annotationParsingDesactived
     */
    public EjbJarFieldMetadataConfigurator(final JField jField, final EjbJarClassMetadata<E> classAnnotationMetadata,
            final boolean annotationParsingDesactived) {
        super(new EjbJarFieldMetadata<E>(jField, classAnnotationMetadata));

        if (!annotationParsingDesactived) {
            registerAnnotationVisitor();
        }
    }

}
